'use strict';

var CurvaABCController = angular.module('CurvaABCController', []);

CurvaABCController.controller('CurvaABCCtrl', ['$scope', '$filter', 'Relatorio', 'CacheApp',
  ($scope, $filter, Relatorio, CacheApp) => {

    $scope.construcao = CacheApp.getConstrucao();
    $scope.assinatura = true;
    $scope.descricaoObra = true;

    $scope.getSelectedMedicao = () => {
        return { Id: 0, Descricao: "Todas as Medições" };
    }
    $scope.selecionado = { Medicao: $scope.getSelectedMedicao() };

    $scope.getMedicoes = () => {
    Relatorio.getMedicoes($scope.construcao.Id,
        (data) => {
            $scope.medicoes = data.Instance;
            $scope.medicoes.unshift($scope.getSelectedMedicao());
        });
    }
    $scope.getMedicoes();

    $scope.changeMedicao = () => {
        //$scope.formulario.Medicao = $scope.selecionado.Medicao.Descricao;
        $scope.getRelatorioCurvaABC();
    }

    $scope.getRelatorioCurvaABC = () => {
          $scope.curvaABC = {};
          Relatorio.getRelatorioCurvaABC($scope.construcao.Id, $scope.selecionado.Medicao.Id,
              (data) => {
                  $scope.curvaABC = data.Instance;
              });
    }
    $scope.getRelatorioCurvaABC();

    $scope.pdfCurvaABC = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta + ' - ' + $scope.selecionado.Medicao.Descricao,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
        };
        if ($scope.descricaoObra == true) {
            cabecalho.DescricaoObra = $scope.construcao.Descricao
        };

        Relatorio.pdfCurvaABC($scope.construcao.Id, $scope.selecionado.Medicao.Id, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsCurvaABC = () => {
    var cabecalho = {
        Avatar: $scope.construcao.ContaAvatar,
        Obra: $scope.construcao.Titulo,
        Conta: $scope.construcao.Conta + ' - ' + $scope.selecionado.Medicao.Descricao,
        DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
        DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
        Moeda: $scope.construcao.Moeda
    };

    Relatorio.xlsCurvaABC($scope.construcao.Id, $scope.selecionado.Medicao.Id, cabecalho,
        (data) => {
            window.location.assign(data.Instance);
        });
    }

}]);
